SliceParameters Class Reference

This class represents the parameters associated to the Slice Algorithm and the similar Bigatti et.al. More...

`#include <SliceParameters.h>`

Inheritance diagram for SliceParameters:

## Public Member Functions

| SliceParameters (bool exposeBoundParams=false, bool exposeIndependenceParam=true, bool supportBigattiAlgorithm=false)
| Construct the parameters with default values.
void | setUseIndependence (bool value)
| Set the value of the independence split option.
void | setSplit (const string &split)
| Set the value of the option for choosing the split selection strategy.
void | validateSplit (bool allowLabel, bool allowDegree)
| Checks that the slice split selection strategy specified is valid.
void | validateSplitHilbert ()
| Checks that the Bigatti Et.al.
bool | getUseBoundElimination () const
| Get the value of the bound elimination option.
bool | getUseBoundSimplification () const
| Get the value of the bound simplification option.
bool | getCanonical () const
| Get the value of the canonical option.
const string & | getSplit () const
| Get the value of the split option.
bool | getPrintDebug () const
| Returns the value of the debug option.
bool | getPrintStatistics () const
| Returns the value of the stats option.
Public Member Functions inherited from ParameterGroup
iterator | begin ()
iterator | end ()
| ParameterGroup ()
virtual | ~ParameterGroup ()
void | addParameter (Parameter *parameter)
void | obtainParameters (vector< Parameter * > &parameters)
virtual void | getValue (string &str) const

## Private Attributes

bool | _exposeBoundParam
bool | _exposeIndependenceParam
BoolParameter | _printDebug
BoolParameter | _printStatistics
BoolParameter | _useBoundElimination
BoolParameter | _useBoundSimplification
BoolParameter | _useIndependence
BoolParameter | _useSimplification
BoolParameter | _minimal
BoolParameter | _canonical
BoolParameter | _useBigattiGeneric
BoolParameter | _widenPivot
StringParameter | _split

## Additional Inherited Members

Public Types inherited from ParameterGroup
typedef vector< Parameter * >::iterator | iterator

## Detailed Description

This class represents the parameters associated to the Slice Algorithm and the similar Bigatti et.al.

Hilbert-Poincare series algorithm. This allows actions to share these options without code duplication. Note that SliceParameters is able to set up a SliceFacade and BigattiFacade according to the parameters it encapsulates.

Definition at line 34 of file SliceParameters.h.

## Constructor & Destructor Documentation

## SliceParameters()

SliceParameters::SliceParameters | ( | bool | exposeBoundParams = false,
|  | bool | exposeIndependenceParam = true,
|  | bool | supportBigattiAlgorithm = false )

Construct the parameters with default values.

Parameters

  exposeBoundParams | Make available parameters related to the bound optimization.
  exposeIndependenceParam | Make available the parameter to turn independence splits on or off.
  supportBigattiAlgorithm | Adjust messages

Definition at line 25 of file SliceParameters.cpp.

## Member Function Documentation

## getCanonical()

bool SliceParameters::getCanonical | ( |  | ) | const

Get the value of the canonical option.

Definition at line 147 of file SliceParameters.cpp.

## getPrintDebug()

bool SliceParameters::getPrintDebug | ( |  | ) | const

Returns the value of the debug option.

Definition at line 190 of file SliceParameters.cpp.

## getPrintStatistics()

bool SliceParameters::getPrintStatistics | ( |  | ) | const

Returns the value of the stats option.

Definition at line 194 of file SliceParameters.cpp.

## getSplit()

const string & SliceParameters::getSplit | ( |  | ) | const

Get the value of the split option.

Definition at line 151 of file SliceParameters.cpp.

## getUseBoundElimination()

bool SliceParameters::getUseBoundElimination | ( |  | ) | const

Get the value of the bound elimination option.

This value has to be exposed as it is not part of the state of a SliceFacade.

Definition at line 139 of file SliceParameters.cpp.

## getUseBoundSimplification()

bool SliceParameters::getUseBoundSimplification | ( |  | ) | const

Get the value of the bound simplification option.

This value has to be exposed as it is not part of the state of a SliceFacade.

Definition at line 143 of file SliceParameters.cpp.

## setSplit()

void SliceParameters::setSplit | ( | const string & | split | ) |

Set the value of the option for choosing the split selection strategy.

This is useful for setting the default value before parsing the user-supplied options.

Definition at line 135 of file SliceParameters.cpp.

## setUseIndependence()

void SliceParameters::setUseIndependence | ( | bool | value | ) |

Set the value of the independence split option.

This is useful for setting the default value before parsing the user-supplied options.

Definition at line 131 of file SliceParameters.cpp.

## validateSplit()

void SliceParameters::validateSplit | ( | bool | allowLabel,
|  | bool | allowDegree )

Checks that the slice split selection strategy specified is valid.

Reports an error otherwise.

Definition at line 155 of file SliceParameters.cpp.

## validateSplitHilbert()

void SliceParameters::validateSplitHilbert | ( |  | ) |

Checks that the Bigatti Et.al.

pivot selection strategy specified is valid. Reports an error otherwise.

Definition at line 181 of file SliceParameters.cpp.

## Member Data Documentation

## _canonical

BoolParameter SliceParameters::_canonical

private

Definition at line 101 of file SliceParameters.h.

## _exposeBoundParam

bool SliceParameters::_exposeBoundParam

private

Definition at line 91 of file SliceParameters.h.

## _exposeIndependenceParam

bool SliceParameters::_exposeIndependenceParam

private

Definition at line 92 of file SliceParameters.h.

## _minimal

BoolParameter SliceParameters::_minimal

private

Definition at line 100 of file SliceParameters.h.

## _printDebug

BoolParameter SliceParameters::_printDebug

private

Definition at line 94 of file SliceParameters.h.

## _printStatistics

BoolParameter SliceParameters::_printStatistics

private

Definition at line 95 of file SliceParameters.h.

## _split

StringParameter SliceParameters::_split

private

Definition at line 105 of file SliceParameters.h.

## _useBigattiGeneric

BoolParameter SliceParameters::_useBigattiGeneric

private

Definition at line 102 of file SliceParameters.h.

## _useBoundElimination

BoolParameter SliceParameters::_useBoundElimination

private

Definition at line 96 of file SliceParameters.h.

## _useBoundSimplification

BoolParameter SliceParameters::_useBoundSimplification

private

Definition at line 97 of file SliceParameters.h.

## _useIndependence

BoolParameter SliceParameters::_useIndependence

private

Definition at line 98 of file SliceParameters.h.

## _useSimplification

BoolParameter SliceParameters::_useSimplification

private

Definition at line 99 of file SliceParameters.h.

## _widenPivot

BoolParameter SliceParameters::_widenPivot

private

Definition at line 103 of file SliceParameters.h.

The documentation for this class was generated from the following files:

- src/SliceParameters.h
- src/SliceParameters.cpp